/* Nintendulator Mapper DLLs
 * Copyright (C) 2002-2011 QMT Productions
 *
 * $URL: https://nintendulator.svn.sourceforge.net/svnroot/nintendulator/mappers/trunk/src/Vs/mapper099.cpp $
 * $Id: mapper099.cpp 1173 2011-01-27 04:24:05Z quietust $
 */

#include	"..\DLL\d_VS.h"
#include	"..\Hardware\h_VS.h"

namespace
{
FCPUWrite _Write;
uint8 CHR;

void	Sync (void)
{
	EMU->SetPRG_RAM8(0x6, 0);
	EMU->SetPRG_ROM32(0x8, 0);
	EMU->SetCHR_ROM8(0, CHR);
	// Vs. Gumshoe has an extra 8KB of PRG ROM which it swaps using the same register
	if (ROM->INES_PRGSize > 2)
		EMU->SetPRG_ROM8(0x8, CHR << 2);
}

int	MAPINT	SaveLoad (STATE_TYPE mode, int offset, unsigned char *data)
{
	SAVELOAD_BYTE(mode, offset, data, CHR);
	offset = VS::SaveLoad(mode, offset, data);
	if (mode == STATE_LOAD)
		Sync();
	return offset;
}

void	MAPINT	Write (int Bank, int Addr, int Val)
{
	_Write(Bank, Addr, Val);
	if (Addr == 0x016)
	{
		CHR = (Val & 0x04) >> 2;
		Sync();
	}
}

BOOL	MAPINT	Load (void)
{
	VS::Load();
	return TRUE;
}
void	MAPINT	Reset (RESET_TYPE ResetType)
{
	EMU->Mirror_4();
	VS::Reset(ResetType);
	_Write = EMU->GetCPUWriteHandler(0x4);
	EMU->SetCPUWriteHandler(0x4, Write);

	if (ResetType == RESET_HARD)
		CHR = 0;
	Sync();
}
void	MAPINT	Unload (void)
{
	VS::Unload();
}

uint8 MapperNum = 99;
} // namespace

const MapperInfo MapperInfo_099 =
{
	&MapperNum,
	_T("VS Unisystem"),
	COMPAT_FULL,
	Load,
	Reset,
	Unload,
	VS::CPUCycle,
	NULL,
	SaveLoad,
	NULL,
	VS::Config
};